#define SIGEL_USE_ONLY

#include <sigel/ISigel.h>

Shader *bump	= 0;
Surface *hc		= 0;
Surface *hc2		= 0;
Texture *dmap	= 0;
Texture *nmap	= 0;
Texture *smap	= 0;

int optimize;

class HeadCrab
{
private:
	float dx,dy;
public:
	Entity *crab;
	HeadCrab();
	~HeadCrab();
	void Update();
};

HeadCrab::HeadCrab()
{

	crab = new Entity(hc);
	crab->BindTex(dmap,0);
//	crab->BindTex(nmap,1);
//	crab->BindTex(smap,2);

//	crab->BindShader(bump);
	crab->Position(rnd(-30,30),rnd(-30,30),rnd(-30,30));
	dx = rnd(-1.0f,1.0f);
	dy = rnd(-1.0f,1.0f);

	//crab->Blend(BM_ADD);
}

HeadCrab::~HeadCrab()
{
	delete crab;
}

void HeadCrab::Update()
{
	crab->Turn(dx,dy,0);
}


sGAME
{
	debug::startlog();
	InitDemo();

	Billboard *lamp = new Billboard(8.0f);

	int cntl = 1;

	Entity **lamps = new Entity*[cntl];
	
	Texture *ltex = new Texture("light.jpg");

	for(int i = 0;i<cntl;++i)
	{
		lamps[i] = new Entity(lamp);
		lamps[i]->Blend(BM_ADD);
		lamps[i]->Position(rnd(-100.0f,100.0f),rnd(-100.0f,100.0f),rnd(-100.0f,100.0f));
		lamps[i]->Rotate(rnd(360.0f),rnd(360.0f),rnd(360.0f));

		lamps[i]->BindTex(ltex);
	}

	int vwait = 0;
	VWait(vwait);

	CameraHelper ch;
	ch.SetMoveSpeed(0.1f);

	int cntc;

	std::ifstream fs("cntheadcrabs.txt");
	fs>>cntc;
	fs.close();

	hc = new Surface("hc.s3m",4.0f);
	int mmmm = GetTickCount();
	
	int tang  = 3;
	

	debug::Log<<"tangents calced by "<<(int)(GetTickCount()-mmmm)<<" msecs"<<std::endl;
	bump = new Shader("BumpFS");
	bump->Compile();
	bump->Bind();
	bump->WriteInt("diffusmap",0);
	bump->WriteInt("normalmap",1);
	bump->WriteInt("specularmap",2);
//	tang = bump->GetAttribLocation("rm_tangent");
//	hc->ReCalcTangents(tang);

	bump->UnBind();


//	bump->WriteAttribLocation("rm_tangent",4);
//	hc->ReCalcTangents(4);

	//Surface(*hc);//
	hc2 = new Surface("hc.s3m",4.0f);
	hc2->Lock();
	hc2->Optimize(true);
	hc2->UnLock();

	debug::Log<<"tang = "<<tang<<std::endl;

	dmap = new Texture("hc.jpg");
	nmap = new Texture("hc_normal.jpg");
	smap = new Texture("hc_specular.jpg");

	HeadCrab *crabs = new HeadCrab[cntc];
	InitBlur();

	optimize = 0;
	while(!KeyDown(VK_ESCAPE))
	{
		if(KeyHit('T')==1)
		{
			tang = 3-tang;
			bump->WriteAttribLocation("rm_tangent",tang);
		}

		if(KeyHit('O')==1)
		{
			optimize = 1-optimize;
			for(int i=0;i<cntc;++i)
			{
				crabs[i].crab->SetSrc(optimize?hc2:hc);
			}
		}

		if(KeyHit('Q')==1)
		{
			vwait = 1-vwait;
			VWait(vwait);
		}

//		bump->Bind();
//		bump->WriteEyeSpaceEntity("lightposition",ch.GetCam());
//		bump->UnBind();

		for(int i=0; i<cntl;++i)
		{
			lamps[i]->Turn(0.5f,0,0);
			lamps[i]->Move(0.1f);
		}

		for(int i=0; i<cntc;++i)
		{
			crabs[i].Update();
		}

		ch.Update();

		Render();
		if(KeyDown(VK_SPACE))
			Blur(0.9f);

		Text(GetFPS(),15,15);
		Text(RenderedTris(),15,30);
		if(!optimize)
			Text("standart(O)",15,45);
		else
			Text("optimize(O)",15,45);

		Flip();
	}

	DeInit();
	debug::endlog();
}